#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDateTime>
#include <QDir>



MainWindow::MainWindow (QWidget *parent)
    :
    QMainWindow (parent),
    ui (new Ui::MainWindow)
{
    ui->setupUi (this);

    ui->treeWidget->setRootIsDecorated (true);

    // ui->treeWidget->header()->hide();

    QStringList labels;
    labels << "Name" << "Date" << "Size";
    ui->treeWidget->setHeaderLabels (labels);

    QDir d0 ("..");
    QDir d (d0.absolutePath());

    QTreeWidgetItem * root = new QTreeWidgetItem;
    root->setText (0, d.dirName ());
    root->setToolTip (0, d.absolutePath());
    root->setForeground (0, QColor ("blue"));
    showDir (root, d.absolutePath());
    ui->treeWidget->addTopLevelItem (root);

    ui->treeWidget->expandItem (root);
}

void MainWindow::showDir (QTreeWidgetItem * target, QString path)
{
    QDir d (path);
    QFileInfoList list = d.entryInfoList (QDir::AllEntries | QDir::NoDotAndDotDot);
    for (QFileInfo f : list)
    {
        QTreeWidgetItem * item = new QTreeWidgetItem (target);
        item->setText (0, f.fileName ());
        item->setToolTip (0, f.absoluteFilePath ());
        if (f.isDir())
        {
            item->setForeground (0, QColor ("blue"));
            showDir (item, f.absoluteFilePath ());
        }
        else if (f.isFile())
        {
            qint64 size = f.size();
            QString s = QString::number (size);
            QString t = "";
            int len = s.length();
            for (int i = 0 ; i < len ; i ++)
            {
               if (i % 3 == 0 && i != 0) t = ' ' + t;
               t = s[len-1-i] + t;
            }
            while (t.length() < 15) t = ' ' + t;

            item->setText (2, t);
            if (size >= 1024)
                item->setForeground (2, QColor ("red"));

            QDateTime u = f.lastModified();
            item->setText (1, u.toString ("yyyy-MM-dd hh:mm:ss"));
        }
    }

}



MainWindow::~MainWindow()
{
    delete ui;
}


